#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "logcut.h"

// mezok: char **mezo
// formatum: char *kiirni
//#define	DEBUG

static char *mut;	// kiirando mezostring mutatoja
static int hatar(int mezoszam);
static int szamkonv();

static char format[30];

void kiir(int mezoszam)
{
int tol,ig,kszam;

#ifdef	DEBUG
printf("--------%d %s\n",mezoszam,kiirni);
#endif
for(kszam=0,mut=kiirni; *mut; )
	{
	tol = hatar(mezoszam);
	if(*mut == '-')
		{
		mut++;
		ig = hatar(mezoszam);
		if(ig < 0)
			ig = mezoszam-1;
		}
	else	ig = tol;
#ifdef	DEBUG
	printf("%d..%d\n",tol,ig);
#endif
	if(*mut == '%')
		{
		int f;
		mut++;
		f = szamkonv();
		sprintf(format,"%%s%%%ds",-f);
		}
	else	strcpy(format,"%s%s");

	if(tol >= 0 && ig >= 0)
		while(tol <= ig)
			{
			printf(format,kszam++? kimhat:"",mezo[tol++]);
			}
	mut += strcspn(mut,",");
	if(*mut == ',')
		mut++;
	}
if(kszam)	// van-e kiirt mezo
	puts("");
}


static int hatar(int mezoszam)
{	// 1-gyel csokkentett erteket ad vissza (1->0)
int ret,i,hossz;

if(isdigit(*mut))
	{
	ret = szamkonv()-1;
	return ret < mezoszam? ret: -1;
	}
if(*mut == '/')		// mezo elejevel megadva
	{
	hossz = strcspn(++mut,"/");	// a minta hossza. mut a minta eleje.
	for(ret=-1,i=0; i < mezoszam; i++)
		if(memcmp(mezo[i],mut,hossz) == 0)
			{
			ret = i;
			break;
			}
	mut += hossz+1;
	return ret;
	}
return -1;
}



static int szamkonv()
{
int ret;

for(ret=0; isdigit(*mut); mut++)
	ret = 10*ret + *mut - '0';
return ret;
}
