#include <stdio.h>
#include <unistd.h>
#include "logcut.h"

struct flagstr flag;
char *mezohat, *kimhat;
char *kiirni = "1-";


static void help(char *prgnev);


int paramsor(int argc, char *argv[])
{
static const char kapcs[] = "hsd:f:D:";
int c;

	// kezdoertekadas
flag.h = flag.s = 0;
mezohat = kimhat = " ";

	// parameterfeldolgozas
while( (c=getopt(argc,argv,kapcs)) >= 0)
	{
	switch(c)
		{
		case 's': flag.s = 1;
			break;
		case 'd': mezohat = optarg;
			break;
		case 'D': kimhat = optarg;
			break;
		case 'f': kiirni = optarg;
			break;
		case 'h': help(argv[0]);
			flag.h = 1;
			break;
		}
#ifdef	DEBUG
	printf("\t-%c: %s\n",c,optarg);
#endif
	}
return flag.h;
}


static void help(char *prgnev)
{
printf("Hivas: %s [ -d bemeno_mezohatar ] [ -s ] [ -D kimeno_hatarstring ] [ -f kiirando_mezok ] [ file... ]\n"
	"\t-s: az egymas utani bemeno_mezohatarok egynek szamitanak\n"
	"\t-h: ez a help\n"
	"kiirando_mezok: mezo[,mezo...]\n"
	"mezo: tol[-[ig]][%%szelesseg]\n"
	"tol, ig: szam | /szoveg_eleje/\n"
,prgnev);
}
